﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ProximityToolkit;
using ProximityToolkit.Networking;
using ProximityToolkit.Presence;

namespace ViconWPFTest
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    /// 
    public partial class Window1 : Window
    {
        private ClientDictionaryManager client = null;
        private ProximitySpace space = null;
        private PresenceBase pencil = null;
        private PresenceBase smartboard = null;
        private PresenceBase jagerHat = null;

        public Window1()
        {
            InitializeComponent();

            client = new ClientDictionaryManager();
            client.Start("127.0.0.1", 888, true);

            space = client.GetSpace();

            pencil = space.GetPresence("Pencil");
            smartboard = space.GetDisplay("Smartboard");
            jagerHat = space.GetPresence("JagerHat");

            pencil.WaitForEmbodiment(0);
            smartboard.WaitForEmbodiment(0);
            jagerHat.WaitForEmbodiment(0);

            space.StartMonitor(pencil, smartboard, ProximityRelation.Location);
            space.StartMonitor(smartboard, jagerHat, ProximityRelation.Location);

            space.RelationUpdated += new SpaceRelationHandler(space_RelationUpdated);

        }

        void space_RelationUpdated(ProximitySpace space, ProximityEventArgs args)
        {
            if(args.PresenceA == pencil)
            {

                TextBlock1.Dispatcher.Invoke(System.Windows.Threading.DispatcherPriority.Normal,
                    new Action(
                        delegate()
                        {
                            TextBlock1.FontSize = 1 + (int)(250 - args.Location.HorizontalDistance / 10);
                        }
                        )); 

            }
            else if (args.PresenceA == smartboard)
            {
                TextBlock2.Dispatcher.Invoke(System.Windows.Threading.DispatcherPriority.Normal,
                    new Action(
                        delegate()
                        {
                            TextBlock2.FontSize = 1 + (int)(250 - args.Location.HorizontalDistance / 10);
                        }
                        )); 
            }
        }
    }
}
